//ADHeader// #import <Cocoa/Cocoa.h>
//ADHeader// #import <QuickTime/QuickTime.h>
//ADHeader// 
//ADSeparator//
#import "Controller.h"
#include <QuickTime/QuickTime.h>
#include "QTUtils.h"
#import "ActiveDeveloperLib.h"

static void * gControllerObject;

@implementation Controller : NSObject
{
    IBOutlet NSButton *	goToBeginningButton;
    IBOutlet NSButton *	goToEndButton;
    IBOutlet NSMovieView *	movieViewObject;
    IBOutlet NSMenuItem *	moviePropertiesMenuItem;
    IBOutlet NSWindow *	moviePropertiesWindow;
    IBOutlet NSWindow *	movieWindow;
    IBOutlet NSButton *	playButton;
    IBOutlet NSSlider *		setVolumeSlider;
    IBOutlet NSButton *	stepBackButton;
    IBOutlet NSButton *	stepForwardButton;
    IBOutlet NSTableView *	movieTrackMediaTypes;
    IBOutlet NSMenuItem *	menuItem_New;
    
    IBOutlet NSTextField *	autoPlayEnabled;
    IBOutlet NSTextField *	trackCount;
    IBOutlet NSTextField *	movieTimeScale;
    IBOutlet NSTextField *	movieDuration;

    NSMutableArray *	movieTrackMediaTypesArray;
    QTCallBackUPP	gMoviePlayingCompleteCallBack;
    QTCallBack		gQtCallBack;
    BOOL			gIsMoviePlaying;
    float 			gMoviePlaybackRate;
    Movie			gMovie;
}
@end


void adjustPlayButtonForMyMovieControllerObject()
{	// Once the movie has stopped playing, QuickTime will call us
    [(Controller *)gControllerObject resetPlayButtonForMovieStopState:nil];
}

pascal void MyCallBackProc (QTCallBack cb, long refcon)
{	//  This is our movie timebase callback routine.
    adjustPlayButtonForMyMovieControllerObject();
    [(Controller *)gControllerObject restoreMoviePlayCompleteCallBack];
}

void saveObjectForCallback(void *theObject)
{	// This routine stores a reference to our Controller object.
   gControllerObject = theObject;
}



//ADSeparator//
//ADHeader// #import "Controller+Methods.h"
//ADHeader// 
//ADHeader// pascal void MyCallBackProc (QTCallBack cb, long refcon);
//ADHeader// void adjustPlayButtonForMyMovieControllerObject(void);
//ADHeader// void saveObjectForCallback(void *theObject);
//ADHeader// 