#import <Cocoa/Cocoa.h>
#import <QuickTime/QuickTime.h>

@interface Controller : NSObject
{
    IBOutlet NSButton *		goToBeginningButton;
    IBOutlet NSButton *		goToEndButton;
    IBOutlet NSMovieView *	movieViewObject;
    IBOutlet NSMenuItem *	moviePropertiesMenuItem;
    IBOutlet NSWindow *		moviePropertiesWindow;
    IBOutlet NSWindow *		movieWindow;
    IBOutlet NSButton *		playButton;
    IBOutlet NSSlider *		setVolumeSlider;
    IBOutlet NSButton *		stepBackButton;
    IBOutlet NSButton *		stepForwardButton;
    IBOutlet NSTableView *	movieTrackMediaTypes;
    IBOutlet NSMenuItem *	menuItem_New;
    
    IBOutlet NSTextField *	autoPlayEnabled;
    IBOutlet NSTextField *	trackCount;
    IBOutlet NSTextField *	movieTimeScale;
    IBOutlet NSTextField *	movieDuration;

    NSMutableArray *	movieTrackMediaTypesArray;
    QTCallBackUPP	gMoviePlayingCompleteCallBack;
    QTCallBack		gQtCallBack;
    BOOL		gIsMoviePlaying;
    float 		gMoviePlaybackRate;
    Movie		gMovie;
}
- (IBAction)goToBeginning:(id)sender;
- (IBAction)goToEnd:(id)sender;
- (IBAction)movieProperties:(id)sender;
- (IBAction)newWindow:(id)sender;
- (IBAction)play:(id)sender;
- (IBAction)setVolume:(id)sender;
- (IBAction)stepBack:(id)sender;
- (IBAction)stepForward:(id)sender;

- (int)numberOfRowsInTableView:(NSTableView *)aTableView;
- (id)tableView:(NSTableView *)aTableView
    objectValueForTableColumn:(NSTableColumn *)aTableColumn
    row:(int)rowIndex;
- (void)resetPlayButtonForMovieStopState:(id)sender;
- (void)buildTrackMediaTypesArray:(Movie)qtmovie;
- (void)saveCurrentMoviePlayingState;
- (void)restoreMoviePlayingState:(id)sender;
- (void)showTheWindow:(NSWindow *)window;
- (void)restoreMoviePlayCompleteCallBack;
- (void)setMoviePropertyWindowControlValues:(Movie)qtmovie;
- (void)setupMoviePlayingCompleteCallback:(Movie)theMovie callbackUPP:(QTCallBackUPP) callbackUPP;

@end

pascal void MyCallBackProc (QTCallBack cb, long refcon);
void adjustPlayButtonForMyMovieControllerObject(void);
void saveObjectForCallback(void *theObject);
